#!/usr/bin/perl -w

# FILENAME: BACKUP.PL
# DESCRIBTION: PHPGW.RU.ONE.DEBUG BACKUP SCRIPT
# UPDATED: 02-03-2005
# AUTHOR: DMITRIEV SERGEY
# USING CODE ALEXANDER MIKHAILOV IGLA.NET

#using modules
use strict;
use locale;

#settings
my $host = 'phpgw.ru';
my $prefix = 'phpgw';
my $home_folder = '/usr/local/psa/home/vhosts/phpgw.ru';
my $backup_folder = $home_folder.'/backup';
my $dump_folder = $backup_folder.'/dump_temporary_dir';
my $db_name = 'phpgw_ru';
my $db_user = 'phpgw';
my $db_password = 'fight';
my $dump_version = 1;
my $mysql_path = '/usr/local/psa/mysql/bin/mysql';
my $mysqldump_path = '/usr/local/psa/mysql/bin/mysqldump';
my ($rm_string,$cp_string);
my @backup_folders= qw(cc cgi-bin httpdocs);

# variables


my $db_dump_file_name = qq~restore\_$db_name\.sql~;
my $restore_file_name=qq~$backup_folder/restore.sh~;
my $backup_file_name="$backup_folder/$prefix\_v$dump_version\_bak.tar";
my $i;

while(-e $backup_file_name){
	$dump_version += 1;
	$backup_file_name = "$backup_folder/$prefix\_v$dump_version\_bak.tar";
}
my $dump_file_notes =qq~# This is $db_name dump\n~;
 
my $system_result=0;
my $error_string; 
my $command_string;
  
$i=0;
foreach $i(@backup_folders){
	$command_string.=" $i";
	$rm_string .= "rm -Rf $home_folder/$i \n";
	$cp_string .= "cp -R $i $home_folder/ \n";
}
 

# actions

# check / create backup, backup temp folder by writing db_dump_file_name empty file
file_write(file_name=>"$backup_folder/test.txt", file_data => "test",  force_path =>  'Y' );
unlink ("$backup_folder/test.txt") || die qq~Can't write to backup folder '$backup_folder'.~; 

# save restore file  
# restore.sh file data

my $restore_file_data=qq~#!/bin/sh
#
# restore site from backup same package it stored in

#
## action
#

# removing old files
echo "Delete existing files..."
$rm_string

# Copying new files
echo "Copying new files ..."
$cp_string

# Setting onwer and mode settings ...
echo "Setting onwer and mode settings ..."
$home_folder/cc/r2.sh

# Replacing  mySQL database
echo "Replacing mySQL database ..."
$mysql_path --user=$db_user --password=$db_password < $db_dump_file_name;

~;  

#save restore file
file_write(file_name=>$restore_file_name, file_data => $restore_file_data,  force_path =>  'Y' ); 
if (system ("chmod 700 $restore_file_name") > 0){
	die "Error: an't change mode of $restore_file_name";
	}
  
# make database dump
file_write(file_name=>"$backup_folder/$db_dump_file_name", file_data => "DROP DATABASE IF EXISTS $db_name;\nCREATE DATABASE $db_name;\nCONNECT $db_name;\n\n",  force_path =>  'Y' );
if (system ("/usr/local/psa/mysql/bin/mysqldump  --user=$db_user --password=$db_password --add-drop-table $db_name >> $backup_folder/$db_dump_file_name") > 0){
	die "Can't make database $db_name dump for you";
}
file_write(file_name=>"$backup_folder/$db_dump_file_name", file_data => "\nexit\n",  append => 'Y' );

# make archive  stage 1
if (system("tar -C $home_folder -cf $backup_file_name $command_string > /dev/null") > 0){
	die "Can't complite stage 1 tar archive creation for you";
}

# make archive  stage 2
if (system("tar -C $backup_folder -rf $backup_file_name $db_dump_file_name restore.sh > /dev/null") > 0){
	die "Can't complite stage 2 tar archive creation for you";
}

# make archive  stage 3
if (system("gzip $backup_file_name") > 0){
	die "Can't complite stage 3 tar archive creation for you";
}

# clean up temp files
unlink ("$backup_folder/$db_dump_file_name") || die qq~Can't delete dump file.~; 
unlink ("$restore_file_name") || die qq~Can't restore script file.~;
  


# == file_write
# writes plan/binary data to file, 
# may create path and upply mode, user & group id
# can't change group id separately
# EXAMPLE: 
# file_write(file_name=>'path_to_file',
#            mode       =>  'bin',
#            file_data  =>  $file_data,
#            append     =>  'Y',
#            force_path =>  'Y'   
#            path_chmod =>  0705,
#            file_chmod =>  0644
#            user       =>  'username'
#            group      =>  'groupname'
#            );
sub file_write{

	# input parsing    
    my %param=@_;
    my $path;
    my $ug;
	 
	# test parameters
    unless ($param{'file_name'}){ die "Specify 'file_name' to write to."; }
    unless ($param{'file_chmod'}){$param{'file_chmod'}=0644;}
    unless ($param{'path_chmod'}){$param{'path_chmod'}=0705;}
    if ($param{'user'} and $param{'group'}){$ug=qq~$param{'user'}\:$param{'group'}~;}
    elsif ($param{'user'}){$ug=qq~$param{'user'}~;}
    
  # if force path
    $path = $param{'file_name'}; $path =~s/(^.*[\|\/]).*/$1/;
    if ($path && $param{'force_path'}){
        unless (-e $path){
                mkpath([$path],0,$param{'path_chmod'});
                if ($ug){
                  if (system("chown $ug $path") > 0){die qq~Can't change owner of "$path" to "$ug"~;}  
                  }
                
        }
        }
    	  
	# do things
	if ($param{'append'} && $param{'append'} eq 'Y') {
		unless (open(FD, ">>$param{'file_name'}")){
			die "Log error: Can't write to '$param{'file_name'}'.";
		}
	}else{
		unless (open(FD, ">$param{'file_name'}")){
			die "Log error: Can't write to '$param{'file_name'}'.";
		}
	}                     
    
    # if we writing binary file
    if ($param{'mode'} && $param{'mode'} eq 'bin'){
        binmode(FD)
	}
    
    print FD $param{'file_data'};
    close FD;
    
    chmod($param{'file_chmod'},$param{'file_name'});
    
	# if user or group specified
    if ($ug){
		if (system("chown $ug $param{'file_name'}") > 0){
			die qq~Can't change owner of "$param{'file_name'}" to "$ug"~;
		}
	}
	return;
}


# EOF