#!/usr/bin/perl -w
#
# SiteFileMode  * Updated 02-10-2004 * by Alexander O. Mikhailov
# 
# For list of options run without arguments 

# modules used     
  use File::Find;
  use vars qw (%opts);

# vars 
  my $name="SiteFileMode";
  my $version ="1.1";
                 
# BEGIN MAIN  

#   
  %opts=getOpts();
 
# unless we have any options, give help to user
  unless ($opts{'mode-dir'} && $opts{'mode-exec'} && $opts{'mode-noexec'} && $opts{'work-dir'}) {
print qq~
$name v.$version. by Alexander O. Mikhailov
Usage: $0 <Options>
<Options>
--work-dir     Directory to modify file modes
--exclude-dir  Path to exclude from operation
--mode-dir     chmod value for folders
--mode-exec    chmod value for executables
--mode-noexec  chmod value for non executables
~;
exit;
}  # end help

#   path
  unless (-d $opts{'work-dir'}){print qq~Path specified in --work-dir does not exist.\n~; exit;}


#    
  find (\&mod_maker,($opts{'work-dir'}));  

#    
  print qq~Task complited\n~;
 
     
# END 

#    chmod       
#   	
sub mod_maker {  
    my $file_name=$File::Find::name;
    my $file_mode;     

unless ($opts{'exclude-dir'} && ($file_name=~/$opts{'exclude-dir'}/)){

  # 
    if  (-d $file_name){ $file_mode=$opts{'mode-dir'}; }
    
  # 
    elsif ((-f $file_name) && ($file_name=~/\.cgi/)){ $file_mode=$opts{'mode-exec'}; }
  
  #   
    else { $file_mode=$opts{'mode-noexec'}; }  
     
  #  
    system ("chmod $file_mode $file_name");
   }
      
} #  


##

sub getOpts {
  
  # vars
    my %opts=();
    my $key;
    
 # iterate args
    foreach $key (@ARGV){
           # read named arg
             if ($key=~/^\-\-(\S*)\=(\S*)/){ $opts{$1}=$2;}
           # read switch            
             elsif ($key=~/^\-(\S*)/){ $opts{$1}=1;}
           # print "\n $1 = $opts{$1}";
    } # end iterate args
    
   # return options  
     return %opts;
} # end sub 

1;

# EOF